package com.loafle.overflow.crawler.wmi;

import com.jacob.activeX.ActiveXComponent;
import com.jacob.com.Dispatch;
import com.jacob.com.EnumVariant;
import com.jacob.com.Variant;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by snoop on 2017-04-11.
 */
public class WMICrawlerWindows extends WMICrawlerOS {

    public Object processWMI(Map<String, Object> params) throws Exception {

        String id = (String)params.get("id");
        String pw = (String)params.get("pw");
        String nameSpace = (String)params.get("nameSpace");
        String query = (String)params.get("query");
        String ip = (String)params.get("ip");

        ActiveXComponent wmi = null;
        wmi = new ActiveXComponent("WbemScripting.SWbemLocator");

        Variant vIp = new Variant(ip);
        Variant vNs = new Variant(nameSpace);
        Variant vId = new Variant(id);
        Variant vPw = new Variant(pw);

        Variant conRet = wmi.invoke("ConnectServer", vIp, vNs, vId, vPw);

        vIp.safeRelease();
        vNs.safeRelease();
        vId.safeRelease();
        vPw.safeRelease();

        Dispatch disConret = conRet.toDispatch();

        ActiveXComponent wmiconnect = new ActiveXComponent(disConret);
        disConret.safeRelease();

        Variant vQuery = new Variant(query);

        Variant vCollection = wmiconnect.invoke("ExecQuery", vQuery);

        wmiconnect.safeRelease();
        vQuery.safeRelease();

        EnumVariant enumVariant = new EnumVariant(vCollection.toDispatch());

        wmi.safeRelease();
        conRet.safeRelease();
        vCollection.safeRelease();


        Variant vItem = null;
        Dispatch item = null;

        List<String> columns = null;
        Map<String, String> resultMap = null;
        List<Map<String, String>> resultMapList = new ArrayList<Map<String, String>>();
        while (enumVariant.hasMoreElements()) {

            vItem = enumVariant.nextElement();
            item = vItem.toDispatch();

            if (columns == null) {
                columns = getColumns(item);
            }

            resultMap = new HashMap<String, String>();
            String name = null;
            String value = null;
            Variant vValue = null;

            for(int indexI = 0 ; indexI < columns.size(); ++indexI) {
                name = columns.get(indexI);
                vValue = Dispatch.call(item, name);
                value = vValue.toString();
                resultMap.put(name, value);
                vValue.safeRelease();
            }

            resultMapList.add(resultMap);

            vItem.safeRelease();
            item.safeRelease();
        }
        return resultMapList;
    }

    protected List<String> getColumns(Dispatch item) {

        List<String> columns = new ArrayList<String>();

        Variant propertyesa = Dispatch.call(item, "Properties_");

        Dispatch disProperty = propertyesa.toDispatch();


        Variant newEnum = Dispatch.call(disProperty, "_NewEnum");

        propertyesa.safeRelease();
        disProperty.safeRelease();

        EnumVariant enumv = newEnum.toEnumVariant();

        newEnum.safeRelease();

        Variant vElem = null;
        Dispatch disElem = null;
        Variant vName = null;

        while (enumv.hasMoreElements()) {
            vElem = enumv.nextElement();
            disElem = vElem.toDispatch();

            vName = Dispatch.call(disElem, "Name");
            String vs = vName.toString();

            columns.add(vs);

            disElem.safeRelease();
            vElem.safeRelease();
            vName.safeRelease();
        }

        enumv.safeRelease();
        return columns;
    }


}
